import time
import board
import displayio
import terminalio
from adafruit_display_text import label
import adafruit_displayio_ssd1306

displayio.release_displays()

# Use for I2C
i2c_bus = board.I2C()  # uses board.SCL and board.SDA
# i2c = board.STEMMA_I2C()  # For using the built-in STEMMA QT connector on a microcontroller
display_bus = displayio.I2CDisplay( i2c_bus, device_address=0x3D )

# Use for SPI
# spi = board.SPI()
# oled_cs = board.D5
# oled_dc = board.D6
# display_bus = displayio.FourWire(spi, command=oled_dc, chip_select=oled_cs,
#                                 reset=oled_reset, baudrate=1000000)

WIDTH = 128
HEIGHT = 64

try:
    display = adafruit_displayio_ssd1306.SSD1306(display_bus, width=WIDTH, height=HEIGHT)
    print( "display OK" )
except:
    print( "display fail" )

loop_count = 0
if display:
    display_group = displayio.Group()
    display.root_group = display_group
    display.show( display_group )
    #background_bitmap = displayio.Bitmap( 128, 64, 1 )
    #background_palette = displayio.Palette(1)
    #background_palette[0] = 0xFFFFFF
    #background_square = displayio.TileGrid( background_bitmap, pixel_shader=background_palette, x=0, y=0 )
    #display_group.append(background_square)

    text = "STELLA"
    text_area = label.Label( terminalio.FONT, text=text, color=0xFFFFFF )
    text_group = displayio.Group( scale=3, x=5, y=16)
    text_group.append( text_area )
    display_group.append( text_group )


    text = "{}".format( loop_count )
    text_area = label.Label( terminalio.FONT, text=text, color=0xFFFFFF )
    text_group = displayio.Group( scale=3, x=50, y=50 )
    text_group.append( text_area )
    display_group.append( text_group )
try:
    while True:
        time.sleep( 1 )
        loop_count += 1
        print( "loop count = {}".format( loop_count ))
        if display:
            text_area.text = str( loop_count )
finally:
        displayio.release_displays()
        print( "displayio displays released" )
        i2c_bus.deinit()
        print( "i2c_bus deinitialized" )
        print( " ---- end --- " )
